diff -urN ipaq-sleep_0.5/CONTROL/conffiles ipaq-sleep_0.7-2/CONTROL/conffiles
--- ipaq-sleep_0.5/CONTROL/conffiles	Wed Dec 31 19:00:00 1969
+++ ipaq-sleep_0.7-2/CONTROL/conffiles	Tue Mar  5 16:08:22 2002
@@ -0,0 +1,3 @@
+/etc/init.d/ipaq-sleep
+/etc/ipaq-sleep.conf
+/etc/X11/Xsession.d/69ipaq-sleep
diff -urN ipaq-sleep_0.5/CONTROL/control ipaq-sleep_0.7-2/CONTROL/control
--- ipaq-sleep_0.5/CONTROL/control	Fri Jan 18 13:31:37 2002
+++ ipaq-sleep_0.7-2/CONTROL/control	Wed Mar 27 10:42:24 2002
@@ -1,11 +1,11 @@
 Package: ipaq-sleep
-Version: 0.5
+Version: 0.7-2
 Priority: optional
 Section: base
 Maintainer: Joe McCarthy <mccarthy@engrng.pitt.edu>
-Depends: libc6
+Depends: libc6, xlibs
 Architecture: arm
-Filename: ./ipaq-sleep_0.5_arm.ipk
+Filename: ./ipaq-sleep_0.7-2_arm.ipk
 Description: An app to dim the backlight and/or put the Ipaq to sleep after a
  predefined period of inactivity. By default it looks at serial, USB,
  touchscreen, button, load average, external power, and audio out with a 5
diff -urN ipaq-sleep_0.5/CONTROL/preinst ipaq-sleep_0.7-2/CONTROL/preinst
--- ipaq-sleep_0.5/CONTROL/preinst	Wed Dec 31 19:00:00 1969
+++ ipaq-sleep_0.7-2/CONTROL/preinst	Tue Mar  5 16:08:05 2002
@@ -0,0 +1,6 @@
+#!/bin/sh
+
+rm -f /tmp/R69ipaq-sleep
+rm -f /etc/rc2.d/S69ipaq-sleep
+rm -f /etc/resume-scripts/R69ipaq-sleep
+rm -f /etc/suspend-scripts/S69ipaq-sleep
diff -urN ipaq-sleep_0.5/etc/X11/Xsession.d/69ipaq-sleep ipaq-sleep_0.7-2/etc/X11/Xsession.d/69ipaq-sleep
--- ipaq-sleep_0.5/etc/X11/Xsession.d/69ipaq-sleep	Wed Dec 31 19:00:00 1969
+++ ipaq-sleep_0.7-2/etc/X11/Xsession.d/69ipaq-sleep	Tue Mar  5 15:01:19 2002
@@ -0,0 +1 @@
+/etc/init.d/ipaq-sleep start
diff -urN ipaq-sleep_0.5/etc/init.d/ipaq-sleep ipaq-sleep_0.7-2/etc/init.d/ipaq-sleep
--- ipaq-sleep_0.5/etc/init.d/ipaq-sleep	Fri Jan 18 13:26:25 2002
+++ ipaq-sleep_0.7-2/etc/init.d/ipaq-sleep	Tue Mar  5 16:06:36 2002
@@ -4,9 +4,6 @@
   start)
        echo -n "Starting sleep daemon: ipaq-sleep"
        mkdir -p /var/run/no-sleep
-       echo "#!/bin/sh" > /tmp/R69ipaq-sleep
-       echo "/etc/init.d/ipaq-sleep start" >> /tmp/R69ipaq-sleep
-       chmod a+x /tmp/R69ipaq-sleep
        start-stop-daemon --start --quiet --exec /usr/bin/ipaq-sleep >/dev/null&
        echo "."
        ;;
diff -urN ipaq-sleep_0.5/etc/ipaq-sleep.conf ipaq-sleep_0.7-2/etc/ipaq-sleep.conf
--- ipaq-sleep_0.5/etc/ipaq-sleep.conf	Fri Jan 18 13:27:15 2002
+++ ipaq-sleep_0.7-2/etc/ipaq-sleep.conf	Tue Mar  5 15:01:19 2002
@@ -1,9 +1,10 @@
-auto-sleep_time	= 180		# auto-sleep time-out in seconds
-dim_time	= 90		# backlight dimmer time-out in seconds
-check_apm	= 1		# apm flag 0=no 1=yes
-debug		= 0		# debug flag 0=no 1=yes
-check_cpu	= 1		# cpu flag 0=no 1=yes
-CPU_value	= 0.05		# CPU gives the cut-off value of load average
-probe_IRQs	= 1		# auto-probe for IRQs 0=no 1=yes		
-#IRQ		= 17		# manually set IRQs to check (this can be done multiple times)
+auto-sleep_time	= 180	# auto-sleep time-out in seconds (<=0 disables)
+dim_time	= 90	# backlight dim time-out in seconds (<=0 disables)
+check_apm	= 1	# apm flag 0=no 1=yes
+X		= 1	# X flag 1=check activity 0=dont
+debug		= 0	# debug flag 0=no 1=yes
+check_cpu	= 1	# cpu flag 0=no 1=yes
+CPU_value	= 0.05	# CPU gives the cut-off value of load average
+probe_IRQs	= 1	# auto-probe for IRQs 0=no 1=yes		
+#IRQ		= 17	# manually set IRQs to check (this can be done multiple times)
 #IRQ		= 20
diff -urN ipaq-sleep_0.5/etc/rc2.d/S69ipaq-sleep ipaq-sleep_0.7-2/etc/rc2.d/S69ipaq-sleep
--- ipaq-sleep_0.5/etc/rc2.d/S69ipaq-sleep	Fri Jan 18 13:26:25 2002
+++ ipaq-sleep_0.7-2/etc/rc2.d/S69ipaq-sleep	Wed Dec 31 19:00:00 1969
@@ -1,23 +0,0 @@
-#! /bin/sh
- 
-case "$1" in
-  start)
-       echo -n "Starting sleep daemon: ipaq-sleep"
-       mkdir -p /var/run/no-sleep
-       echo "#!/bin/sh" > /tmp/R69ipaq-sleep
-       echo "/etc/init.d/ipaq-sleep start" >> /tmp/R69ipaq-sleep
-       chmod a+x /tmp/R69ipaq-sleep
-       start-stop-daemon --start --quiet --exec /usr/bin/ipaq-sleep >/dev/null&
-       echo "."
-       ;;
-  stop)
-       echo -n "Stopping sleep daemon: ipaq-sleep"
-       start-stop-daemon --stop --quiet --oknodo --exec /usr/bin/ipaq-sleep
-       echo "."
-       ;;
-  *)
-       echo "Usage: /etc/init.d/ipaq-sleep {start|stop}"
-       exit 1
-esac
-
-exit 0                                                                         
diff -urN ipaq-sleep_0.5/etc/suspend-scripts/S69ipaq-sleep ipaq-sleep_0.7-2/etc/suspend-scripts/S69ipaq-sleep
--- ipaq-sleep_0.5/etc/suspend-scripts/S69ipaq-sleep	Fri Jan 18 13:25:48 2002
+++ ipaq-sleep_0.7-2/etc/suspend-scripts/S69ipaq-sleep	Wed Dec 31 19:00:00 1969
@@ -1,5 +0,0 @@
-#!/bin/sh
-# Stops ipaq-sleep so we don't need to worry about
-# counting time while asleep
-
-/etc/init.d/ipaq-sleep stop
Binary files ipaq-sleep_0.5/usr/bin/ipaq-sleep and ipaq-sleep_0.7-2/usr/bin/ipaq-sleep differ