diff -urN ipkg_0.9-jehb/CONTROL/conffiles ipkg_0.99.9-2/CONTROL/conffiles
--- ipkg_0.9-jehb/CONTROL/conffiles	Wed Dec 31 19:00:00 1969
+++ ipkg_0.99.9-2/CONTROL/conffiles	Sat Mar 16 12:54:23 2002
@@ -0,0 +1 @@
+/etc/ipkg.conf
diff -urN ipkg_0.9-jehb/CONTROL/control ipkg_0.99.9-2/CONTROL/control
--- ipkg_0.9-jehb/CONTROL/control	Thu Jan 31 14:37:04 2002
+++ ipkg_0.99.9-2/CONTROL/control	Fri Apr 19 10:45:07 2002
@@ -1,9 +1,20 @@
 Package: ipkg
+Version: 0.99.9-2
 Section: base
-Essential: yes
 Priority: required
-Version: 0.9-jehb
+Essential: yes
 Architecture: arm
-Maintainer: Carl Worth <cworth@handhelds.org>
-Depends: fileutils, shellutils, textutils, sed, grep, gzip, tar, wget
-Description: Lightweight package management system
+Maintainer: Carl Worth <cworth@east.isi.edu>
+Depends: libc6, wget 
+Description: lightweight package management system
+ ipkg is the Itsy Package Management System, for handling
+ installation and removal of packages on a system. It can
+ recursively follow dependencies and download all packages
+ necessary to install a particular package.
+ .
+ ipkg knows how to install both .ipk and .deb packages.
+ .
+ ipkg is intended to serve the same functions (and more) for
+ Familiar that dpkg and apt serve for Debian, (while taking
+ up much less space).
+
diff -urN ipkg_0.9-jehb/CONTROL/control~ ipkg_0.99.9-2/CONTROL/control~
--- ipkg_0.9-jehb/CONTROL/control~	Wed Dec 31 19:00:00 1969
+++ ipkg_0.99.9-2/CONTROL/control~	Sat Mar 16 12:54:23 2002
@@ -0,0 +1,20 @@
+Package: ipkg
+Version: 0.99.9-1
+Section: base
+Priority: required
+Essential: yes
+Architecture: arm
+Maintainer: Carl Worth <cworth@east.isi.edu>
+Depends: libc6, wget 
+Description: lightweight package management system
+ ipkg is the Itsy Package Management System, for handling
+ installation and removal of packages on a system. It can
+ recursively follow dependencies and download all packages
+ necessary to install a particular package.
+ .
+ ipkg knows how to install both .ipk and .deb packages.
+ .
+ ipkg is intended to serve the same functions (and more) for
+ Familiar that dpkg and apt serve for Debian, (while taking
+ up much less space).
+
diff -urN ipkg_0.9-jehb/CONTROL/postinst ipkg_0.99.9-2/CONTROL/postinst
--- ipkg_0.9-jehb/CONTROL/postinst	Thu Jan 31 14:37:04 2002
+++ ipkg_0.99.9-2/CONTROL/postinst	Wed Dec 31 19:00:00 1969
@@ -1,33 +0,0 @@
-#!/bin/sh
-set -e
-
-if [ ! -e /etc/ipkg.conf ]; then
-	echo "Installing new /etc/ipkg.conf (Maintainer's version)"
-	cp /etc/ipkg.conf-dist $PKG_ROOT/etc/ipkg.conf
-else
-	if grep -q '^[[:space:]]*IPKG_SOURCE' /etc/ipkg.conf; then
-		mv /etc/ipkg.conf /etc/ipkg.conf-old
-		echo "Backed up /etc/ipkg.conf to /etc/ipkg.conf-old"
-		echo -n "Converting old /etc/ipkg.conf to new format..."
-		echo "# /etc/ipkg.conf -- configuration file for ipkg
-#
-# This file was automatically generated from your old ipkg.conf, (which
-# has been saved as /etc/ipkg.conf-old). If you would like to see a
-# clean version of this file with some documentation, see the
-# maintainer's version at $PKG_ROOT/etc/ipkg.conf.
-" >> /etc/ipkg.conf
-		sed -ne 's/^[[:space:]]*IPKG_SOURCE="\?\(.*:\/\/\([^/]*\)[^"]*\)"\?/src \2 \1/p' /etc/ipkg.conf-old >> /etc/ipkg.conf
-		sed -ne 's/^[[:space:]]*#[[:space:]]*IPKG_SOURCE="\?\(.*:\/\/\([^/]*\)[^"]*\)"\?/#src \2 \1/p' /etc/ipkg.conf-old >> /etc/ipkg.conf
-		echo "
-dest root /
-dest ram /mnt/ramfs
-dest ext /mnt/hda
-" >> /etc/ipkg.conf
-
-		sed -ne 's/^[[:space:]]*IPKG_PROXY_HTTP="\?\([^"]*\)"\?/option http_proxy \1/p' /etc/ipkg.conf-old >> /etc/ipkg.conf
-		sed -ne 's/^[[:space:]]*IPKG_PROXY_FTP="\?\([^"]*\)"\?/option ftp_proxy \1/p' /etc/ipkg.conf-old >> /etc/ipkg.conf
-		sed -ne 's/^[[:space:]]*IPKG_PROXY_USERNAME="\?\([^"]*\)"\?/option proxy_username \1/p' /etc/ipkg.conf-old >> /etc/ipkg.conf
-		sed -ne 's/^[[:space:]]*IPKG_PROXY_PASSWORD="\?\([^"]*\)"\?/option proxy_username \1/p' /etc/ipkg.conf-old >> /etc/ipkg.conf
-		echo "Done."
-	fi
-fi
diff -urN ipkg_0.9-jehb/etc/ipkg.conf ipkg_0.99.9-2/etc/ipkg.conf
--- ipkg_0.9-jehb/etc/ipkg.conf	Wed Dec 31 19:00:00 1969
+++ ipkg_0.99.9-2/etc/ipkg.conf	Sat Mar 16 12:54:22 2002
@@ -0,0 +1,31 @@
+# /etc/ipkg.conf -- Configuration for ipkg, the Itsy PacKaGe management system
+#
+# Must have one or more source entries of the form:
+#
+#	src <src-name> <source-url>
+#
+# and one or more destination entries of the form:
+#
+#	dest <dest-name> <target-path>
+#
+# where <src-name> and <dest-names> are identifiers that
+# should match [a-zA-Z0-9._-]+, <source-url> should be a
+# URL that points to a directory containing a Familiar
+# Packages file, and <target-path> should be a directory
+# that exists on the target system.
+
+src familiar-unstable http://familiar.handhelds.org/familiar/feeds/unstable/packages/armv4l
+
+dest root /
+dest ram /mnt/ramfs
+dest ext /mnt/hda
+
+# Proxy support:
+#
+#option http_proxy http://localhost:5865
+#option ftp_proxy http://proxy.tld:3128
+#option proxy_username <username>
+#option proxy_password <password>
+
+# Offline mode (for use in constructing flash images offline)
+# option offline_root ipkg-root
diff -urN ipkg_0.9-jehb/etc/ipkg.conf-dist ipkg_0.99.9-2/etc/ipkg.conf-dist
--- ipkg_0.9-jehb/etc/ipkg.conf-dist	Thu Jan 31 14:37:04 2002
+++ ipkg_0.99.9-2/etc/ipkg.conf-dist	Wed Dec 31 19:00:00 1969
@@ -1,29 +0,0 @@
-# Must have one or more source entries of the form:
-#
-#	src <src-name> <source-url>
-#
-# and one or more destination entries of the form:
-#
-#	dest <dest-name> <target-path>
-#
-# where <src-name> and <dest-names> are identifiers that
-# should match [a-zA-Z0-9._-]+, <source-url> should be a
-# URL that points to a directory containing a Familiar
-# Packages file, and <target-path> should be a directory
-# that exists on the target system.
-
-src familiar-unstable http://familiar.handhelds.org/familiar/feeds/unstable/packages/armv4l
-
-dest root /
-dest ram /mnt/ramfs
-dest ext /mnt/hda
-
-# Proxy support:
-#
-#option http_proxy http://proxy.tld:3128
-#option ftp_proxy http://proxy.tld:3128
-#option proxy_username <username>
-#option proxy_password <password>
-
-# Offline mode (for use in constructing flash images offline)
-#option offline_root target
Binary files ipkg_0.9-jehb/usr/bin/ipkg and ipkg_0.99.9-2/usr/bin/ipkg differ
Binary files ipkg_0.9-jehb/usr/bin/ipkg-compare-versions and ipkg_0.99.9-2/usr/bin/ipkg-compare-versions differ
diff -urN ipkg_0.9-jehb/usr/bin/update-alternatives ipkg_0.99.9-2/usr/bin/update-alternatives
--- ipkg_0.9-jehb/usr/bin/update-alternatives	Wed Dec 31 19:00:00 1969
+++ ipkg_0.99.9-2/usr/bin/update-alternatives	Sat Mar 16 12:54:23 2002
@@ -0,0 +1,188 @@
+#!/bin/sh
+# update-alternatives
+#
+# Copyright (C) 2001 Carl D. Worth
+#
+# This program was inspired by the Debian update-alternatives program
+# which is Copyright (C) 1995 Ian Jackson. This version of
+# update-alternatives is command-line compatible with Debian's for a
+# subset of the options, (only --install, --remove, and --help)
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+set -e
+
+# admin dir
+ad="$IPKG_OFFLINE_ROOT/usr/lib/ipkg/alternatives"
+
+usage() {
+	echo "update-alternatives: $*
+
+Usage: update-alternatives --install <link> <name> <path> <priority>
+       update-alternatives --remove <name> <path>
+       update-alternatives --help
+<link> is the link pointing to the provided path (ie. /usr/bin/foo).
+<name> is the name in $ad/alternatives (ie. foo)
+<path> is the name referred to (ie. /usr/bin/foo-extra-spiffy)
+<priority> is an integer; options with higher numbers are chosen.
+" >&2
+	exit 2
+}
+
+quit() {
+	echo "update-alternatives: $*" >&2
+	exit 2
+}
+
+register_alt() {
+	[ $# -lt 2 ] && return 1
+	local name="$1"
+	local link="$2"
+
+	if [ ! -d $ad ]; then
+		mkdir -p $ad
+	fi
+
+	if [ -e "$ad/$name" ]; then
+		local olink=`head -1 $ad/$name`
+		if [ "$link" != "$olink" ]; then
+			echo "update-alternatives: Error: cannot register alternative $name to $link since it is already registered to $olink" >&2
+			return 1
+		fi
+	else
+		echo "$link" > "$ad/$name"
+	fi
+
+	return 0
+}
+
+protect_slashes() {
+	sed -e 's/\//\\\//g'
+}
+
+remove_alt() {
+	[ $# -lt 2 ] && return 1
+	local name="$1"
+	local path="$2"
+	
+	[ ! -f $ad/$name ] && return 0
+
+	path=`echo $path | protect_slashes`
+	sed -ne "/^$path\>.*/!p" $ad/$name > $ad/$name.new
+	mv $ad/$name.new $ad/$name
+}
+
+add_alt() {
+	[ $# -lt 3 ] && return 1
+	local name="$1"
+	local path="$2"
+	local priority="$3"
+	remove_alt $name $path
+	echo "$path $priority" >> $ad/$name
+}
+
+find_best_alt() {
+	[ $# -lt 1 ] && return 1
+	[ ! -f $ad/$name ] && return 0
+
+	link=$IPKG_OFFLINE_ROOT/`head -1 $ad/$name`
+
+	path=`sed -ne "1!p" $ad/$name | sort -nr -k2 | head -1 | sed 's/ .*//'`
+	if [ -z "$path" ]; then
+		echo "update-alternatives: removing $link as no more alternatives exist for it"
+		rm $ad/$name
+		if [ -L $link ]; then
+			rm $link
+		fi
+		return 0
+	fi
+
+	if [ ! -e $link -o -L $link ]; then
+		local link_dir=`dirname $link`
+		if [ ! -d $link_dir ]; then
+			mkdir -p $link_dir
+		fi
+		rm -f $link
+		ln -s $path $link
+		echo "update-alternatives: Linking $link to $path"
+	else
+		echo "update-alternatives: Error: not linking $link to $path since $link exists and is not a link"
+		return 1
+	fi
+
+	return 0
+}
+
+do_install() {
+	if [ $# -lt 4 ]; then
+		usage "--install needs <link> <name> <path> <priority>"
+	fi
+	local link="$1"
+	local name="$2"
+	local path="$3"
+	local priority="$4"
+
+	path=`echo $path | sed 's|/\+|/|g'`
+
+	# This is a bad hack, but I haven't thought of a cleaner solution yet...
+	[ -n "$IPKG_OFFLINE_ROOT" ] && path=`echo $path | sed "s|^$IPKG_OFFLINE_ROOT/*|/|"`
+
+	register_alt $name $link
+	add_alt $name $path $priority
+	find_best_alt $name
+}
+
+do_remove() {
+       if [ $# -lt 2 ]; then
+		usage "--remove needs <name> <path>"
+	fi	
+	local name="$1"
+	local path="$2"
+
+	path=`echo $path | sed 's|/\+|/|g'`
+
+	# This is a bad hack, but I haven't thought of a cleaner solution yet...
+	[ -n "$IPKG_OFFLINE_ROOT" ] && path=`echo $path | sed "s|^$IPKG_OFFLINE_ROOT/*|/|"`
+
+	remove_alt $name $path
+	find_best_alt $name
+}
+
+###
+# update-alternatives "main"
+###
+
+while [ $# -gt 0 ]; do
+	arg="$1"
+	shift
+
+	case $arg in
+	--help)
+		usage "help:"
+		exit 0
+		;;
+	--install)
+		do_install $*
+		exit $?
+		;;
+	--remove)
+		do_remove $*
+		exit $?
+		;;
+	*)
+		usage "unknown argument \`$arg'"
+		;;
+	esac
+done
+
+usage "at least one of --install or --remove must appear"
+
+exit 0
diff -urN ipkg_0.9-jehb/usr/bin/update-menus ipkg_0.99.9-2/usr/bin/update-menus
--- ipkg_0.9-jehb/usr/bin/update-menus	Thu Jan 31 14:37:04 2002
+++ ipkg_0.99.9-2/usr/bin/update-menus	Wed Dec 31 19:00:00 1969
@@ -1,9 +0,0 @@
-#!/bin/sh
-set -e
-
-#simple to start...
-for script in /etc/menu-methods/*; do
-	if [ -x "$script" ]; then
-		$script
-	fi
-done
diff -urN ipkg_0.9-jehb/usr/sbin/update-alternatives ipkg_0.99.9-2/usr/sbin/update-alternatives
--- ipkg_0.9-jehb/usr/sbin/update-alternatives	Thu Jan 31 14:37:04 2002
+++ ipkg_0.99.9-2/usr/sbin/update-alternatives	Wed Dec 31 19:00:00 1969
@@ -1,184 +0,0 @@
-#!/bin/sh
-# update-alternatives
-#
-# Copyright (C) 2001 Carl D. Worth
-#
-# This program was inspired by the Debian update-alternatives program
-# which is Copyright (C) 1995 Ian Jackson. This version of
-# update-alternatives is command-line compatible with Debian's for a
-# subset of the options, (only --install, --remove, and --help)
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2, or (at your option)
-# any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-set -e
-
-# admin dir
-ad="$IPKG_OFFLINE_ROOT/usr/lib/ipkg/alternatives"
-
-usage() {
-	echo "update-alternatives: $*
-
-Usage: update-alternatives --install <link> <name> <path> <priority>
-       update-alternatives --remove <name> <path>
-       update-alternatives --help
-<link> is the link pointing to the provided path (ie. /usr/bin/foo).
-<name> is the name in $ad/alternatives (ie. foo)
-<path> is the name referred to (ie. /usr/bin/foo-extra-spiffy)
-<priority> is an integer; options with higher numbers are chosen.
-" >&2
-	exit 2
-}
-
-quit() {
-	echo "update-alternatives: $*" >&2
-	exit 2
-}
-
-register_alt() {
-	[ $# -lt 2 ] && return 1
-	local name="$1"
-	local link="$2"
-
-	if [ ! -d $ad ]; then
-		mkdir -p $ad
-	fi
-
-	if [ -e "$ad/$name" ]; then
-		local olink=`head -1 $ad/$name`
-		if [ "$link" != "$olink" ]; then
-			echo "update-alternatives: Error: cannot register alternative $name to $link since it is already registered to $olink" >&2
-			return 1
-		fi
-	else
-		echo "$link" > "$ad/$name"
-	fi
-
-	return 0
-}
-
-protect_slashes() {
-	sed -e 's/\//\\\//g'
-}
-
-remove_alt() {
-	[ $# -lt 2 ] && return 1
-	local name="$1"
-	local path="$2"
-	
-	[ ! -f $ad/$name ] && return 0
-
-	path=`echo $path | protect_slashes`
-	sed -ne "/^$path\>.*/!p" $ad/$name > $ad/$name.new
-	mv $ad/$name.new $ad/$name
-}
-
-add_alt() {
-	[ $# -lt 3 ] && return 1
-	local name="$1"
-	local path="$2"
-	local priority="$3"
-	remove_alt $name $path
-	echo "$path $priority" >> $ad/$name
-}
-
-find_best_alt() {
-	[ $# -lt 1 ] && return 1
-	[ ! -f $ad/$name ] && return 0
-
-	link=$IPKG_OFFLINE_ROOT/`head -1 $ad/$name`
-
-	path=`sed -ne "1!p" $ad/$name | sort -nr -k2 | head -1 | sed 's/ .*//'`
-	if [ -z "$path" ]; then
-		echo "update-alternatives: removing $link as no more alternatives exist for it"
-		rm $ad/$name
-		if [ -L $link ]; then
-			rm $link
-		fi
-		return 0
-	fi
-
-	if [ ! -e $link -o -L $link ]; then
-		rm -f $link
-		ln -s $path $link
-		echo "update-alternatives: Linking $link to $path"
-	else
-		echo "update-alternatives: Error: not linking $link to $path since $link exists and is not a link"
-		return 1
-	fi
-
-	return 0
-}
-
-do_install() {
-	if [ $# -lt 4 ]; then
-		usage "--install needs <link> <name> <path> <priority>"
-	fi
-	local link="$1"
-	local name="$2"
-	local path="$3"
-	local priority="$4"
-
-	path=`echo $path | sed 's|/\+|/|g'`
-
-	# This is a bad hack, but I haven't thought of a cleaner solution yet...
-	[ -n "$IPKG_OFFLINE_ROOT" ] && path=`echo $path | sed "s|^$IPKG_OFFLINE_ROOT/*|/|"`
-
-	register_alt $name $link
-	add_alt $name $path $priority
-	find_best_alt $name
-}
-
-do_remove() {
-       if [ $# -lt 2 ]; then
-		usage "--remove needs <name> <path>"
-	fi	
-	local name="$1"
-	local path="$2"
-
-	path=`echo $path | sed 's|/\+|/|g'`
-
-	# This is a bad hack, but I haven't thought of a cleaner solution yet...
-	[ -n "$IPKG_OFFLINE_ROOT" ] && path=`echo $path | sed "s|^$IPKG_OFFLINE_ROOT/*|/|"`
-
-	remove_alt $name $path
-	find_best_alt $name
-}
-
-###
-# update-alternatives "main"
-###
-
-while [ $# -gt 0 ]; do
-	arg="$1"
-	shift
-
-	case $arg in
-	--help)
-		usage "help:"
-		exit 0
-		;;
-	--install)
-		do_install $*
-		exit $?
-		;;
-	--remove)
-		do_remove $*
-		exit $?
-		;;
-	*)
-		usage "unknown argument \`$arg'"
-		;;
-	esac
-done
-
-usage "at least one of --install or --remove must appear"
-
-exit 0
diff -urN ipkg_0.9-jehb/usr/share/doc/ipkg/copyright ipkg_0.99.9-2/usr/share/doc/ipkg/copyright
--- ipkg_0.9-jehb/usr/share/doc/ipkg/copyright	Thu Jan 31 14:37:04 2002
+++ ipkg_0.99.9-2/usr/share/doc/ipkg/copyright	Sat Mar 16 12:54:23 2002
@@ -1,4 +1,5 @@
-Copyright (c) 2001 Carl D. Worth
+Copyright (c) 2001 University of Southern California
+Copyright (c) 2002 Compaq Computer Corporation
 
 This program is free software; you can redistribute it and/or modify it
 under the terms of the GNU General Public License as published by the