diff -urN ssh_2.5.2p2-2-fam7/CONTROL/control ssh_2.5.2p2-2-fam9/CONTROL/control
--- ssh_2.5.2p2-2-fam7/CONTROL/control	Wed Jan 30 12:13:13 2002
+++ ssh_2.5.2p2-2-fam9/CONTROL/control	Wed Feb 27 14:32:47 2002
@@ -6,7 +6,7 @@
 Maintainer: Carl Worth <cworth@handhelds.org>
 Architecture: arm
 Source: openssh
-Version: 1:2.5.2p2-2-fam7
+Version: 1:2.5.2p2-2-fam9
 Depends: libc6 (>= 2.2.1-2), libpam0g (>= 0.72-1), libssl0.9.6, libwrap0, zlib1g (>= 1:1.1.3), libpam-modules (>= 0.72-9), libwrap0 (>= 7.6-1.1)
 Suggests: ssh-askpass, debconf, xbase-clients, dpkg (>= 1.8.3.1)
 Conflicts: ssh-nonfree, ssh-socks, ssh2, debconf (<< 0.2.17), debconf-tiny (<< 0.2.17), sftp, rsh-client (<< 0.16.1-1)
diff -urN ssh_2.5.2p2-2-fam7/CONTROL/control~ ssh_2.5.2p2-2-fam9/CONTROL/control~
--- ssh_2.5.2p2-2-fam7/CONTROL/control~	Wed Jan 30 11:16:30 2002
+++ ssh_2.5.2p2-2-fam9/CONTROL/control~	Fri Feb  1 10:40:07 2002
@@ -1,5 +1,4 @@
 Package: ssh
-InstallsOffline: no
 Priority: optional
 Section: non-US
 Installed-Size: 1020
@@ -7,7 +6,7 @@
 Maintainer: Carl Worth <cworth@handhelds.org>
 Architecture: arm
 Source: openssh
-Version: 1:2.5.2p2-2-fam6
+Version: 1:2.5.2p2-2-fam8
 Depends: libc6 (>= 2.2.1-2), libpam0g (>= 0.72-1), libssl0.9.6, libwrap0, zlib1g (>= 1:1.1.3), libpam-modules (>= 0.72-9), libwrap0 (>= 7.6-1.1)
 Suggests: ssh-askpass, debconf, xbase-clients, dpkg (>= 1.8.3.1)
 Conflicts: ssh-nonfree, ssh-socks, ssh2, debconf (<< 0.2.17), debconf-tiny (<< 0.2.17), sftp, rsh-client (<< 0.16.1-1)
diff -urN ssh_2.5.2p2-2-fam7/etc/init.d/ssh ssh_2.5.2p2-2-fam9/etc/init.d/ssh
--- ssh_2.5.2p2-2-fam7/etc/init.d/ssh	Wed Jan 30 12:11:30 2002
+++ ssh_2.5.2p2-2-fam9/etc/init.d/ssh	Wed Feb 27 14:34:23 2002
@@ -5,6 +5,8 @@
 test -x /usr/sbin/sshd || exit 0
 ( /usr/sbin/sshd -\? 2>&1 | grep -q OpenSSH ) 2>/dev/null || exit 0
 
+PATH=$PATH:/usr/bin
+
 # forget it if we're trying to start, and /etc/ssh/NOSERVER exists
 if expr "$1" : '.*start$' >/dev/null && [ -e /etc/ssh/NOSERVER ]; then 
     echo "Not starting OpenBSD Secure Shell server (/etc/ssh/NOSERVER)"
@@ -12,7 +14,7 @@
 fi
 
 update_sshd_config() {
-    protocols = ""
+    protocols=""
     if [ -e /etc/ssh/ssh_host_dsa_key ]; then
 	if [ -e /etc/ssh/ssh_host_key ]; then
 	    protocols="Protocol 2,1"
diff -urN ssh_2.5.2p2-2-fam7/etc/init.d/ssh~ ssh_2.5.2p2-2-fam9/etc/init.d/ssh~
--- ssh_2.5.2p2-2-fam7/etc/init.d/ssh~	Wed Dec 31 19:00:00 1969
+++ ssh_2.5.2p2-2-fam9/etc/init.d/ssh~	Wed Feb 27 14:33:48 2002
@@ -0,0 +1,85 @@
+#! /bin/sh
+
+# /etc/init.d/ssh: start and stop the OpenBSDh "secure shell(tm)" daemon
+
+test -x /usr/sbin/sshd || exit 0
+( /usr/sbin/sshd -\? 2>&1 | grep -q OpenSSH ) 2>/dev/null || exit 0
+
+PATH=/bin:/usr/bin:/usr/local/bin
+
+# forget it if we're trying to start, and /etc/ssh/NOSERVER exists
+if expr "$1" : '.*start$' >/dev/null && [ -e /etc/ssh/NOSERVER ]; then 
+    echo "Not starting OpenBSD Secure Shell server (/etc/ssh/NOSERVER)"
+    exit 0
+fi
+
+update_sshd_config() {
+    protocols=""
+    if [ -e /etc/ssh/ssh_host_dsa_key ]; then
+	if [ -e /etc/ssh/ssh_host_key ]; then
+	    protocols="Protocol 2,1"
+	else
+	    protocols="Protocol 2"
+	fi
+    else
+	if [ -e /etc/ssh/ssh_host_key ]; then
+	    protocols="Protocol 1"
+	fi
+    fi
+    sed "s/^Protocol.*/$protocols/" < /etc/ssh/sshd_config > /tmp/sshd_config
+    cp /tmp/sshd_config /etc/ssh/sshd_config
+}
+
+# Configurable options:
+
+case "$1" in
+  start)
+	test -f /etc/ssh/sshd_not_to_be_run && exit 0
+	if ! [ -e /etc/ssh/ssh_host_dsa_key ]; then
+	    /etc/init.d/ssh keygen2
+	fi
+
+        echo -n "Starting OpenBSD Secure Shell server: sshd"
+	start-stop-daemon --start --quiet --pidfile /var/run/sshd.pid --exec /usr/sbin/sshd
+        echo "."
+	;;
+  stop)
+        echo -n "Stopping OpenBSD Secure Shell server: sshd"
+	start-stop-daemon --stop --quiet --oknodo --pidfile /var/run/sshd.pid --exec /usr/sbin/sshd
+        echo "."
+	;;
+
+  reload|force-reload)
+        echo -n "Reloading OpenBSD Secure Shell server's configuration"
+	start-stop-daemon --stop --signal 1 --quiet --oknodo --pidfile /var/run/sshd.pid --exec /usr/sbin/sshd
+	echo "."
+	;;
+
+  restart)
+        echo -n "Restarting OpenBSD Secure Shell server: sshd"
+	start-stop-daemon --stop --quiet --oknodo --pidfile /var/run/sshd.pid --exec /usr/sbin/sshd
+	sleep 10
+	start-stop-daemon --start --quiet --pidfile /var/run/sshd.pid --exec /usr/sbin/sshd
+	echo "."
+	;;
+
+  keygen1)
+	echo "Generating SSH RSA host key (this is slow, please be patient)... "
+	/usr/bin/ssh-keygen -f /etc/ssh/ssh_host_key -N '' 
+	echo "Done."
+	update_sshd_config
+	;;
+
+  keygen2)
+	echo "Generating SSH DSA host key (this is slow, please be patient)... "
+	/usr/bin/ssh-keygen -d -f /etc/ssh/ssh_host_dsa_key -N '' 
+	echo "Done."
+	update_sshd_config
+	;;
+
+  *)
+	echo "Usage: /etc/init.d/ssh {start|stop|reload|force-reload|restart|keygen1|keygen2}"
+	exit 1
+esac
+
+exit 0
diff -urN ssh_2.5.2p2-2-fam7/etc/rc2.d/S50ssh ssh_2.5.2p2-2-fam9/etc/rc2.d/S50ssh
--- ssh_2.5.2p2-2-fam7/etc/rc2.d/S50ssh	Wed Jan 30 12:11:30 2002
+++ ssh_2.5.2p2-2-fam9/etc/rc2.d/S50ssh	Wed Feb 27 14:34:23 2002
@@ -5,6 +5,8 @@
 test -x /usr/sbin/sshd || exit 0
 ( /usr/sbin/sshd -\? 2>&1 | grep -q OpenSSH ) 2>/dev/null || exit 0
 
+PATH=$PATH:/usr/bin
+
 # forget it if we're trying to start, and /etc/ssh/NOSERVER exists
 if expr "$1" : '.*start$' >/dev/null && [ -e /etc/ssh/NOSERVER ]; then 
     echo "Not starting OpenBSD Secure Shell server (/etc/ssh/NOSERVER)"
@@ -12,7 +14,7 @@
 fi
 
 update_sshd_config() {
-    protocols = ""
+    protocols=""
     if [ -e /etc/ssh/ssh_host_dsa_key ]; then
 	if [ -e /etc/ssh/ssh_host_key ]; then
 	    protocols="Protocol 2,1"